/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TaxaEmbarqueParadaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.TaxaEmbarqueParada;
import com.rjconsultores.ventaboletos.service.TaxaEmbarqueParadaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.vo.esquemaoperacional.TaxaEmbarqueW2i;

import java.sql.SQLException;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Desenvolvimento
 */
@Service("taxaEmbarqueParadaService")
public class TaxaEmbarqueParadaServiceImpl implements TaxaEmbarqueParadaService {

    @Autowired
    private TaxaEmbarqueParadaDAO taxaEmbarqueParadaDAO;

    public List<TaxaEmbarqueParada> obtenerTodos() {
        return taxaEmbarqueParadaDAO.obtenerTodos();
    }

    public TaxaEmbarqueParada obtenerID(Integer id) {
        return taxaEmbarqueParadaDAO.obtenerID(id);
    }

    @Transactional
    public TaxaEmbarqueParada suscribir(TaxaEmbarqueParada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return taxaEmbarqueParadaDAO.suscribir(entidad);
    }

    @Transactional
    public TaxaEmbarqueParada actualizacion(TaxaEmbarqueParada entidad) {
        return taxaEmbarqueParadaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TaxaEmbarqueParada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        taxaEmbarqueParadaDAO.borrar(entidad);
    }

    public List<TaxaEmbarqueParada> buscarPorLocalidade(Parada parada) {
        return taxaEmbarqueParadaDAO.buscarPorLocalidade(parada);
    }
    
    public List<TaxaEmbarqueW2i> buscarEstoqueTaxaEmbarque(Parada origem, Empresa empresa, String txtKm, OrgaoConcedente orgao, Categoria categoria) throws SQLException {
    	 return taxaEmbarqueParadaDAO.buscarEstoqueTaxaEmbarque(origem, empresa, txtKm, orgao, categoria);
    }
}
